{
 use strict;

 use Cmiss::Cmgui_command_data;
 use Cmiss::Node;
 use Cmiss::Region;

my $draw_xray_as_surfaces = 1;

sub initialise_camera_view
 {

	gfx create material bone_xray ambient 0.7 0.7 0.6 diffuse 0 0 0 emission 0.9 0.9 0.7 specular 0 0 0 alpha 0.03 shininess 0.2;

  gfx create win xray_view;

  gfx create scene xray_view manual;

  gfx modify win xray_view image scene xray_view;

  gfx draw group hip/hip scene xray_view;

  gfx modify g_element hip/hip general clear circle_discretization 12 default_coordinate hip_position element_discretization "1*1*1" native_discretization none scene xray_view;

	gfx define field xray_ndc_coordinates window_projection field coordinates window xray_view ndc_projection;
   gfx define field xi.1 component xi.1;
   gfx define field xi.3 component xi.3;

  if ($draw_xray_as_surfaces)
	 {
		gfx create material bone_xray ambient 0.7 0.7 0.6 diffuse 0 0 0 emission 0.9 0.9 0.7 specular 0 0 0 alpha 0.1 shininess 0.2;
		gfx modify g_element hip/hip surfaces material bone_xray scene xray_view;
	 }
	else
	 {

	 }

  gfx draw group femur/left_femur scene xray_view;

  gfx modify g_element femur/left_femur general clear circle_discretization 12 default_coordinate femur_position element_discretization "1*1*1" native_discretization none scene xray_view;

  if ($draw_xray_as_surfaces)
	 {
		gfx modify g_element femur/left_femur surfaces material bone_xray scene xray_view;
	 }
	else
	 {
		gfx read elements femur_bounding_box region femur;

		gfx define faces egroup femur/femur_bounding_box;
		gfx draw group femur/femur_bounding_box scene xray_view;

		gfx modify g_element femur/femur_bounding_box general clear circle_discretization 12 default_coordinate coordinates element_discretization "1*1*1" native_discretization none scene xray_view;

		gfx create texture femur_density width 1 height 1 depth 1 specify_format ia image femur_density0.sgi number_pattern 0 number_series 0 511 1 modulate linear compress;
		gfx create material femur_density ambient 1 1 1 diffuse 0 0 0 emission 0.74 0.84 0.62 specular 0 0 0 alpha 0.04 shininess 0 texture femur_density;

		gfx define field femur_texture_coordinates composite xi.1 xi.3 xi.2

      Cmiss::Cmgui_command_data::cmiss("gfx modify g_element femur/femur_bounding_box iso_surfaces iso_scalar xray_ndc_coordinates.3 iso_values " . join(" ", map{-0.65-$_*0.001}(0..250)) . " material femur_density scene xray_view texture_coordinates femur_texture_coordinates");
	 }

  if ($draw_xray_as_surfaces)
	 {
	   gfx mod win xray_view set order 5;
	 }
	else
	 {
	   #gfx mod win xray_view set order 5;
	 }
 }

sub update_camera_view
 {

	#Evaluate the nodal value into an fe_field so that we can extract it.
	Cmiss::Cmgui_command_data::cmiss("gfx define field evaluate_coordinates finite_element number_of_components 3;");

	Cmiss::Cmgui_command_data::cmiss("gfx evaluate source rotated_coordinates destination evaluate_coordinates ngroup ccarm/cccamera;");
	

 my $root_region = $Cmiss::Cmgui_command_data->get_cmiss_root_region();

 my $ccarm = $root_region->get_sub_region(name=>'ccarm');

 my $node = $ccarm->get_node(name=>'82');



  }

 initialise_camera_view();

 update_camera_view();

}

