{

my $i;

if (!defined $setup)
 {
	$setup = 0;
 }

gfx read node left_femur.exnode;
gfx read elem left_femur.exelem;
gfx define field femur_position offset field coordinates offsets -79 65 962;

gfx modify g_element left_femur general default_coordinate femur_position ;

gfx read elements femur_bounding_box;
gfx define faces egroup femur_bounding_box;

my @box_left = (90, 170, 125);
my @box_right = (190, 270, -385);
my @box_width;
my @box_centre;
for ($i = 0 ; $i < scalar @box_left ; $i++)
 {
	 $box_width[$i] = $box_right[$i] - $box_left[$i];
	 $box_centre[$i] = $box_left[$i] + 0.5 * $box_width[$i];
 }


my $scaling = 1000;
my $window_width = $scaling * 1;
my $window_height = $scaling * 1;

my @texture_size = (64, 64, 512);


my $lookat_offset = 300;
my $view_angle = 2 * 180.0 / 3.14159 * atan2(sqrt($box_width[0] * $box_width[0] + $box_width[1] * $box_width[1]) / 2.0, $lookat_offset);

print("View angle $view_angle\n");

gfx create win 1;
gfx modify win 1 layout width $window_width height $window_height;
gfx modify window 1 view parallel eye_point $box_centre[0] $box_centre[1] ($box_centre[2]+$lookat_offset) interest_point @box_centre up_vector 0 1 0 view_angle $view_angle near_clipping_plane 10.7264 far_clipping_plane 3833.27 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1;

gfx modify g_element left_femur general clear  element_discretization "10*10*10";
gfx modify g_element femur_bounding_box general clear;

 #We want the antialiased samples to affect the alpha value in the resulting texture
 #and not the actual colour value.  So make the background colour white so it matches the
 #material we are drawing with
if ($setup)
 {
	gfx mod win 1 background colour 0 0 0;
 }
 else
 {
	gfx mod win 1 background colour 1 1 1;
 }

gfx read curve bone_density_profile;

gfx define field surface_distance xi_texture_coordinates seed_element 1;
gfx define field surface_distance.3 component surface_distance.3;
gfx define field surface_density curve_lookup curve bone_density_profile source surface_distance.3;

gfx create spectrum alpha_spectrum clear overwrite_colour
gfx modify spectrum alpha_spectrum linear range 0 1 extend_above extend_below alpha colour_range 0 1 component 1

 gfx define field coordinates.z component femur_position.3;
 gfx modify g_element left_femur iso_surfaces as slice iso_scalar coordinates.z iso_values 0.0 use_elements select_on material default selected_material default_selected render_shaded data surface_density spectrum alpha_spectrum;

 if (!$setup)
 {
	for ($i = 0 ; $i < $texture_size[2] ; $i++)
	{
	  my $depth = $box_left[2] + ((0.5 + $i) / ($texture_size[2] - 1)) * $box_width[2];

	  print "$depth\n";

	  gfx define field coordinates.z component femur_position.3;
	  gfx modify g_element left_femur iso_surfaces as slice iso_values $depth;

	  gfx print win 1 file femur_density$i.sgi width $texture_size[0] height $texture_size[1] anti 8;
	}

	quit;
 }
}
