
function init()
{
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

  var minVersion = "0.5.0";
  var maxVersion = "0.5.0";

  if (mozCmguiCheckValidVersion(minVersion, maxVersion))
  {
	  mozCmguiInitialise(new CmguiReady());
  }
  else
  {
    actualVersion = mozCmguiVersion();
    alert("The installed version of mozCmgui is not valid for this application. \n" +
		 "Version installed : " + actualVersion +
		 "\nMinimum allowable version :" + minVersion +
		 "\nMaximum allowable version :" + maxVersion + "\n");
  }
}

function draw_wall(wall_image_file, wall)
{
	cmgui_exec("gfx create texture walls3_" + wall +
		" image memory:/" + wall_image_file + ";");
	cmgui_exec("gfx create material walls3_" + wall +
		" texture walls3_" + wall + ";");

	cmgui_exec("gfx draw group walls3/" + wall + " scene walls3;");
	
	cmgui_exec("gfx modify g_element walls3/" + wall +
		" general clear circle_discretization 6 default_coordinate coordinates element_discretization \"4*4*4\" native_discretization none scene walls3;");
	cmgui_exec("gfx modify g_element walls3/" + wall + 
		" surfaces select_on material walls3_" + wall + 
		" selected_material default_selected render_shaded texture_coordinates xi scene walls3;");

}

function setup_walls()
{
	cmgui_exec("gfx read elements memory:/walls3.exelem region walls3;");
	cmgui_exec("gfx create scene walls3 manual;");
	cmgui_exec("gfx draw group walls3/walls scene walls3;");
	cmgui_exec("gfx modify g_element walls3/walls general clear circle_discretization 6 default_coordinate coordinates element_discretization \"4*4*4\" native_discretization none scene walls3;");
	cmgui_exec("gfx modify g_element walls3/walls surfaces select_on material default selected_material default_selected render_shaded scene walls3;");

	draw_wall("back3.jpg", "back_wall");
	draw_wall("front3.jpg", "front_wall");
	draw_wall("left3.jpg", "left_wall");
	draw_wall("right3.jpg", "right_wall");
	draw_wall("floor3.jpg", "floor");

	cmgui_exec("gfx draw child walls3 scene default;");
}

function initialise_camera_position()
{
	update_camera_position(0, 0, 0, 0, 0, 0);

	cmgui_exec("gfx define field sin_angles sin field angles;");
	cmgui_exec("gfx define field minus_sin_angles scale field sin_angles scale_factors -1 -1 -1;");
	cmgui_exec("gfx define field cos_angles cos field angles;");
   //First rotation matrix
	cmgui_exec("gfx define field rotation_matrix_alpha composite cos_angles.1 sin_angles.1 0.0 minus_sin_angles.1 cos_angles.1 0.0 0.0 0.0 1.0;");
   //Second rotation matrix
	cmgui_exec("gfx define field rotation_matrix_beta composite 1.0 0.0 0.0 0.0 cos_angles.2 sin_angles.2 0.0 minus_sin_angles.2 cos_angles.2;");
	cmgui_exec("gfx define field rotation_matrix matrix_multiply number_of_rows 3 fields rotation_matrix_alpha rotation_matrix_beta;");
	cmgui_exec("gfx define field rotated_coordinates matrix_multiply number_of_rows 3 fields rotation_matrix translate_coordinates;");
	cmgui_exec("gfx define field dx_ds1 coordinate_system rectangular_cartesian node_value fe_field coordinates d/ds1 version 1;");
	cmgui_exec("gfx define field rotated_dx_ds1 matrix_multiply number_of_rows 3 fields rotation_matrix dx_ds1;");
}

function update_camera_position(transX, transY, transZ, rotX, rotY, rotZ )
{
	cmgui_exec("gfx define field translate_coordinates offset field coordinates offsets "
		+ transX + " " + transY + " " + transZ + ";");
	cmgui_exec("gfx define field angles composite "
		+ rotX + " " + rotY + " " + rotZ + ";");

	window.currentPosition = [transX, transY, transZ, rotX, rotY, rotZ];

	update_camera_view();
}

function rotate_intensifier(angle1, angle2)
{
	var current = window.currentPosition;
	update_camera_position(current[0], current[1], current[2],
		current[3] + angle1, current[4] + angle2, current[5]);
}

function translate_intensifier(x, y)
{
	var current = window.currentPosition;
	update_camera_position(current[0] + x, current[1] + y, current[2],
		current[3], current[4], current[5]);
}

function draw_ccarm()
{
	initialise_camera_position();

	cmgui_exec("gfx read elem memory:/ccarm3.exelem region ccarm;");
	cmgui_exec("gfx create scene ccsupport manual;");
	cmgui_exec("gfx draw group ccarm/ccsupport scene ccsupport;");

	cmgui_exec("gfx modify g_element ccarm/ccsupport general clear circle_discretization 12 default_coordinate rotated_coordinates element_discretization \"12*12*12\" native_discretization none scene ccsupport;");
	cmgui_exec("gfx modify g_element ccarm/ccsupport cylinders constant_radius 40 select_on material blue selected_material default_selected scene ccsupport;");

	cmgui_exec("gfx create scene ccarm manual;");

	cmgui_exec("gfx draw group ccarm/ccarm scene ccarm;");
	cmgui_exec("gfx modify g_element ccarm/ccarm general clear circle_discretization 12 default_coordinate rotated_coordinates element_discretization \"12*12*12\" native_discretization none scene ccarm;");
	cmgui_exec("gfx modify g_element ccarm/ccarm cylinders constant_radius 40 select_on material blue selected_material default_selected scene ccarm;");

	cmgui_exec("gfx draw group ccarm/ccweight scene ccarm;");
	cmgui_exec("gfx modify g_element ccarm/ccweight general clear circle_discretization 12 default_coordinate rotated_coordinates element_discretization \"12*12*12\" native_discretization none scene ccarm;");
	cmgui_exec("gfx modify g_element ccarm/ccweight node_points glyph cube_solid general size \"110*110*110\" centre 0,0,0 orientation rotated_dx_ds1 scale_factors \"0*0*0\" select_on material blue selected_material default_selected scene ccarm;");

	cmgui_exec("gfx draw group ccarm/cccamera scene ccarm;");
	cmgui_exec("gfx modify g_element ccarm/cccamera general clear circle_discretization 6 default_coordinate rotated_coordinates element_discretization \"4*4*4\" native_discretization none scene ccarm;");
	cmgui_exec("gfx modify g_element ccarm/cccamera node_points glyph cylinder_solid_hires general size \"110*110*110\" centre 0.5,0,0 orientation rotated_dx_ds1 scale_factors \"0*0*0\" select_on material blue selected_material default_selected scene ccarm;");

	//Draw this into the default scene
	cmgui_exec("gfx draw child ccarm scene ccsupport;");

	//Draw this into the default scene
	cmgui_exec("gfx draw child ccsupport scene default;");
}

function draw_bones()
{
	cmgui_exec("gfx read node memory:/left_femur.exnode region femur;");
	cmgui_exec("gfx read elem memory:/left_femur.exelem region femur;");

	cmgui_exec("gfx read node memory:/hip_a.exnode region hip;");
	cmgui_exec("gfx read elem memory:/hip_a.exelem region hip;");

	cmgui_exec("gfx create scene bones manual;");

	cmgui_exec("gfx draw group hip/hip scene bones;");
	cmgui_exec("gfx define field hip_position offset field coordinates offsets 0 0 0;");
	cmgui_exec("gfx modify g_element hip/hip general clear circle_discretization 12 default_coordinate hip_position element_discretization \"12*12*12\" native_discretization none scene bones;");
	cmgui_exec("gfx modify g_element hip/hip surfaces material bone scene bones;");

	cmgui_exec("gfx draw group femur/left_femur scene bones;");
	cmgui_exec("gfx define field femur_position offset field coordinates offsets -79 65 962;");
	cmgui_exec("gfx modify g_element femur/left_femur general clear circle_discretization 12 default_coordinate femur_position element_discretization \"12*12*12\" native_discretization none scene bones;");
	cmgui_exec("gfx modify g_element femur/left_femur surfaces material bone scene bones;");

	//Draw this into the default scene
	cmgui_exec("gfx draw child bones scene default;");
}

function initialise_camera_view()
{
	cmgui_exec("gfx create scene xray_view manual;");
	
	cmgui_exec("gfx draw group hip/hip scene xray_view;");
	cmgui_exec("gfx modify g_element hip/hip general clear circle_discretization 12 default_coordinate hip_position element_discretization \"10*10*10\" native_discretization none scene xray_view;");

	cmgui_exec("gfx create material bone_xray ambient 0.7 0.7 0.6 diffuse  0.9 0.9 0.7 emission 0 0 0 specular 0 0 0 alpha 0.3 shininess 0.8;");
	cmgui_exec("gfx modify g_element hip/hip surfaces material bone_xray scene xray_view exterior;");

	cmgui_exec("gfx draw group femur/left_femur scene xray_view;");

	cmgui_exec("gfx modify g_element femur/left_femur general clear circle_discretization 12 default_coordinate femur_position element_discretization \"10*10*10\" native_discretization none scene xray_view;");
	
	cmgui_exec("gfx modify g_element femur/left_femur surfaces material bone_xray scene xray_view exterior;");

 }

function initialise_camera_view_points()
{
	cmgui_exec("gfx create scene xray_view manual;");
	
	cmgui_exec("gfx create material bone_xray ambient 0.7 0.7 0.6 diffuse  0.9 0.9 0.7 emission 0 0 0 specular 0 0 0 alpha 0.2 shininess 0.8;");

	cmgui_exec("gfx define curve bone_density_profile c.Hermite number_of_components 1 extend_clamp file memory:/bone_density_profile max_value 1 min_value 0 parameter_grid 0.1 value_grid 0.1;");

	cmgui_exec("gfx define field hip_surface_distance xi_texture_coordinates region hip seed_element 1;");
	cmgui_exec("gfx define field hip_surface_distance.1 component hip_surface_distance.1;");
	cmgui_exec("gfx define field hip_surface_density curve_lookup curve bone_density_profile source hip_surface_distance.1;");
	cmgui_exec("gfx define field hip_bone_density scale field hip_surface_density scale_factors 2.5;");

	cmgui_exec("gfx draw group hip/hip scene xray_view;");
	cmgui_exec("gfx modify g_element hip/hip general clear circle_discretization 12 default_coordinate hip_position element_discretization \"10*10*10\" native_discretization none scene xray_view;");
	cmgui_exec("gfx modify g_element hip/hip element_points scene xray_view glyph point general size \"1*1*1\" centre 0,0,0 font default use_elements cell_poisson density hip_bone_density discretization \"6*6*6\" native_discretization NONE select_on material bone_xray selected_material default_selected;");

	cmgui_exec("gfx define field femur_surface_distance xi_texture_coordinates region femur seed_element 1;");
	cmgui_exec("gfx define field femur_surface_distance.3 component femur_surface_distance.3;");
	cmgui_exec("gfx define field femur_surface_density curve_lookup curve bone_density_profile source femur_surface_distance.3;");
	cmgui_exec("gfx define field femur_bone_density scale field femur_surface_density scale_factors 2.5;");

	cmgui_exec("gfx draw group femur/left_femur scene xray_view;");
	cmgui_exec("gfx modify g_element femur/left_femur general clear circle_discretization 12 default_coordinate femur_position element_discretization \"10*10*10\" native_discretization none scene xray_view;");
	cmgui_exec("gfx modify g_element femur/left_femur element_points scene xray_view glyph point general size \"1*1*1\" centre 0,0,0 font default use_elements cell_poisson density femur_bone_density discretization \"6*6*6\" native_discretization NONE select_on material bone_xray selected_material default_selected;");

 }

function update_camera_view()
{
	// Only do this if the xrayViewer is displayed
	if (window.xrayViewer)
	{
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

		var values = {};
		var count = {};
		var time = 0;
		var root_region = window.commandData.rootRegion;

		ccarm = root_region.getSubRegion("ccarm");
		node = ccarm.getNode("82");
		
		rotated_coordinates = window.commandData.findFieldByName(
			"rotated_coordinates");

		rotated_coordinates.evaluateAtNode(node, time, values, count);
		position = values.value;

		rotated_dx_ds1 = window.commandData.findFieldByName(
			"rotated_dx_ds1");

		rotated_dx_ds1.evaluateAtNode(node, time, values, count);
		dx_ds1 = values.value;

		//cmgui_exec("print \"" + 
		//	position[0] + " " + position[1] + " " +  position[2] + " " + 
		//	(position[0] + dx_ds1[0]) + " " + 
		//	(position[1] + dx_ds1[1]) + " " +
		//	(position[2] + dx_ds1[2]) + "\n\";");
		window.xrayViewer.setLookatParametersNonSkew(
			position[0], position[1], position[2],
			position[0] + dx_ds1[0], position[1] + dx_ds1[1], position[2] + dx_ds1[2],
			0, 0, 1);
		window.xrayViewer.setNearAndFarPlane(10,1000);
		//Radians
		window.xrayViewer.viewAngle = 2.8;
	}
}

function setup_scenes()
{
	//Make the default scene manual so it doesn't just try and display all regions
	cmgui_exec("gfx modify scene default manual;");

	// Define a top level coordinates field
	cmgui_exec("gfx define field coordinates finite_element number_of_components 3;");

	setup_walls();

	draw_ccarm();
	
	draw_bones();

	//initialise_camera_view();
	initialise_camera_view_points();
	
	setup_cmgui_windows();

	setup_steps();
}

function InitialiseSceneViewers()
{
	var simulatorViewer = window.simulatorViewer;
	var xrayViewer = window.xrayViewer;
	
	netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

	//window.commandData.executeCommand('print \"InitialiseSceneViewers just entered\\n\"');

	simulatorViewer.setBackgroundColourRGB(0.0, 0.0, 0.0);
	simulatorViewer.setWindowSize(window.plugin.width, window.plugin.height);
	simulatorViewer.setLookatParametersNonSkew(
		0, 0, 1000,
		0, 0, 0,
		0, 1, 0);
	simulatorViewer.setNearAndFarPlane(
		10, 10000);
	// Radians
	simulatorViewer.viewAngle = 1.5;

	xrayViewer.setWindowSize(window.plugin2.width, window.plugin2.height);

	xrayViewer.setSceneByName("xray_view");

	update_camera_view();

	//xrayViewer.transparencyLayers = 5;
	//xrayViewer.transparencyMode = 
	//	Components.interfaces.CmguiISceneViewer.TRANSPARENCY_ORDER_INDEPENDENT;
	xrayViewer.transparencyMode = 
		Components.interfaces.CmguiISceneViewer.TRANSPARENCY_SLOW;
}

function update_step()
{
	var progress = document.getElementById("completion-progressmeter");
	var html_object = document.getElementById("help-html-object");
	
	completed = window.completedSteps / window.totalSteps;
	progress.setAttribute("value", completed * 100);

	tags = ["help/help.htm#ii",
		"help/help.htm#tt",
		"help/help.htm#skin",
		"help/help.htm#guide",
		"help/help.htm#dhs",
		"help/help.htm#cortic",
		"help/help.htm#fin"];

	html_object.setAttribute("src", tags[window.completedSteps]);	
}

function setup_steps()
{
	window.completedSteps = 0;
	window.totalSteps = 6;

	update_step();
}

function previous_step()
{
	if (window.completedSteps > 0)
	{
		window.completedSteps--;
	}
	update_step();
}

function next_step()
{
	if (window.completedSteps < window.totalSteps)
	{
		window.completedSteps++;
	}
	update_step();
}

///////////////////////////////////////////////////////////////////////////////////////

function load_files()
{
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

    //  from local file system
    // Note the downloading is asynchronous so we need to wait for all of these to finish before
    // continuing. The DownloadMonitor object keeps track of the number of downloads in progress.
    // A counter will be incremented when an asynchronous download is started
    // and decremented when download is complete and the memory block defined
    // When counter returns to 0 the callback function will be executed, ie carry on.
    // 
    // Note there is a very small race condition here. The first download could complete
    // before the second has started.
    var dm = Components.classes["@physiome.org/mozCmgui/mozDownloadMonitor;1"]
                      .createInstance(Components.interfaces.mozIDownloadMonitor);
    dm.onDownloadsCompleted = new RunnableFunctionWrapper(setup_scenes);

    var files = [
		 "walls3.exelem",
		 "back3.jpg",
		 "front3.jpg",
		 "left3.jpg",
		 "right3.jpg",
		 "floor3.jpg",
		 "ccarm3.exelem",
		 "left_femur.exnode",
		 "left_femur.exelem",
		 "hip_a.exnode",
		 "hip_a.exelem",
		 "bone_density_profile.curve.exnode",
		 "bone_density_profile.curve.exelem"];

	 for (i = 0 ;  i < files.length ; i++)
	 {
		 filename = files[i];
		 memoryname = '/' + files[i];

		 window.mozCmguiDefineMemoryBlock(commandData, dm, filename, memoryname);
	 }
}

function RunnableFunctionWrapper(aFunction)
{
  this.run = aFunction;
}

RunnableFunctionWrapper.prototype =
{
  QueryInterface: function(aIID)
  {
    if (aIID.equals(Components.interfaces.nsIRunnable) ||
        aIID.equals(Components.interfaces.nsISupports))
      return this;
    throw Components.results.NS_NOINTERFACE;
  }
};

function RunnableFunctionWrapperArgument2(aFunction, arg1, arg2)
{
  this.run_function = aFunction;
  this.arg1 = arg1;
  this.arg2 = arg2;
}

RunnableFunctionWrapperArgument2.prototype =
{
  QueryInterface: function(aIID)
  {
    if (aIID.equals(Components.interfaces.nsIRunnable) ||
        aIID.equals(Components.interfaces.nsISupports))
      return this;
    throw Components.results.NS_NOINTERFACE;
  },

  run: function()
  {
	  this.run_function(this.arg1, this.arg2);
  }
};

function emptyObject()
{
}

function CmguiReady()
{
}


CmguiReady.prototype =
{
  QueryInterface: function(aIID)
  {
    if (
        aIID.equals(Components.interfaces.CmguiIApplicationBootstrap) ||
        aIID.equals(Components.interfaces.CmguiISceneViewerResultMonitor) ||
	aIID.equals(Components.interfaces.nsISupports)
       )
    {
      return this;
    }
    throw Components.results.NS_NOINTERFACE;
  },

  cmguiReady: function(cdf)
  {
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    window.commandData = cdf.createCommandData();
	 
	 load_files();

  },

  sceneViewerReady: function(sceneViewer)
  {
    // This is just a sample of how this interface could be put on the cmguiReady object.
    // However in this demo we define scene1Ready object to handle the initialisation of the scene following
    // downloading of the content and execution of the command file. 
  }
};


function scene1Ready()
{
}

scene1Ready.prototype =
{
  QueryInterface: function(aIID)
  {
    if (
        aIID.equals(Components.interfaces.CmguiISceneViewerResultMonitor)
       )
    {
      return this;
    }
    throw Components.results.NS_NOINTERFACE;
  },

  sceneViewerReady: function(sceneViewer)
  {
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    window.plugin.resizeMonitor =
      mozCmguiProxyToMain(new mozCmguiResizeMonitor(sceneViewer, window.plugin),
                  Components.interfaces.mozIPluginResizeMonitor);

	 window.simulatorViewer = sceneViewer;

	 if (window.xrayViewer)
	 {
		 InitialiseSceneViewers();
	 }

  }

};

function scene2Ready()
{
}

scene2Ready.prototype =
{
  QueryInterface: function(aIID)
  {
    if (
        aIID.equals(Components.interfaces.CmguiISceneViewerResultMonitor)
       )
    {
      return this;
    }
    throw Components.results.NS_NOINTERFACE;
  },

  sceneViewerReady: function(sceneViewer)
  {
    netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    window.plugin2.resizeMonitor =
      mozCmguiProxyToMain(new mozCmguiResizeMonitor(sceneViewer, window.plugin2),
                  Components.interfaces.mozIPluginResizeMonitor);

	 window.xrayViewer = sceneViewer;

	 if (window.simulatorViewer)
	 {
		 InitialiseSceneViewers();
	 }	 
  }

};

function setup_cmgui_windows()
{
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

  var plugin = document.getElementById("SimulatorWindow");
  window.plugin = plugin;
  var windowId = plugin.window;

  window.sceneViewer =
    window.commandData.createSceneViewer(windowId,
    mozCmguiProxyToMain(new scene1Ready(),
    Components.interfaces.CmguiISceneViewerResultMonitor));

  var plugin2 = document.getElementById("XRayWindow");
  window.plugin2 = plugin2;
  var windowId2 = plugin2.window;

  window.sceneViewer2 =
    window.commandData.createSceneViewer(windowId2,
    mozCmguiProxyToMain(new scene2Ready(),
    Components.interfaces.CmguiISceneViewerResultMonitor));

}

function cmgui_exec(command_string)
{
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");

  mozCmguiRunSafe(function(){
		  try
		  {
			  window.commandData.executeCommand(command_string);
		  }
		  catch (error)
		  {
			  throw error;
		  }
	  });
}
