{
 use strict;
 use Cmiss::Cmgui_command_data;

 our @camera_position = (0, 0, 0, 0, 0, 0);

 sub initialise_camera_position
 {
   my @translate = (0.0, 0.0, 0.0);

   my @rotate = (0.0, 0.0, 0.0);

	Cmiss::Cmgui_command_data::cmiss("gfx define field translate_coordinates offset field coordinates offsets @translate;");

	Cmiss::Cmgui_command_data::cmiss("gfx define field angles composite @rotate;");

	Cmiss::Cmgui_command_data::cmiss("gfx define field sin_angles sin field angles;");

	Cmiss::Cmgui_command_data::cmiss("gfx define field minus_sin_angles scale field sin_angles scale_factors -1 -1 -1;");

	Cmiss::Cmgui_command_data::cmiss("gfx define field cos_angles cos field angles;");

   #First rotation matrix
	Cmiss::Cmgui_command_data::cmiss("gfx define field rotation_matrix_alpha composite cos_angles.1 sin_angles.1 0.0 minus_sin_angles.1 cos_angles.1 0.0 0.0 0.0 1.0;");

   #Second rotation matrix
	Cmiss::Cmgui_command_data::cmiss("gfx define field rotation_matrix_beta composite 1.0 0.0 0.0 0.0 cos_angles.2 sin_angles.2 0.0 minus_sin_angles.2 cos_angles.2;");

	Cmiss::Cmgui_command_data::cmiss("gfx define field rotation_matrix matrix_multiply number_of_rows 3 fields rotation_matrix_alpha rotation_matrix_beta;");

	Cmiss::Cmgui_command_data::cmiss("gfx define field rotated_coordinates matrix_multiply number_of_rows 3 fields rotation_matrix translate_coordinates;");
	
	Cmiss::Cmgui_command_data::cmiss("gfx define field dx_ds1 coordinate_system rectangular_cartesian node_value fe_field coordinates d/ds1 version 1;");

	Cmiss::Cmgui_command_data::cmiss("gfx define field rotated_dx_ds1 matrix_multiply number_of_rows 3 fields rotation_matrix dx_ds1;");
 }

 sub update_camera_position
 {
   my @translate = (shift, shift, shift);

   my @rotate = (shift, shift, shift);

	Cmiss::Cmgui_command_data::cmiss("gfx define field translate_coordinates offset field coordinates offsets @translate;");

	Cmiss::Cmgui_command_data::cmiss("gfx define field angles composite @rotate;");

	if (defined &update_camera_view)
	  {
		 update_camera_view();
	  }
 }

 sub rotate_camera
 {
	  my $angle_1 = shift;
	  my $angle_2 = shift;

     $camera_position[3] += $angle_1;
     $camera_position[4] += $angle_2;

	  update_camera_position(@camera_position);
 }

 initialise_camera_position();

 update_camera_position(@camera_position);
}
